Attribute VB_Name = "allgemein"
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.
'
'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !

'==========================================
' Funktion:     Hook + API + Konstanten,...
' Author:       Stefan Bergmann
' email:        silberfische@gmx.de
'==========================================

Option Explicit

'============================
' Konstanten Tastaturereignis
'============================
Private Const WM_KEYDOWN = &H100
Private Const WM_KEYUP = &H101
Private Const WM_SYSKEYDOWN = &H104
Private Const WM_SYSKEYUP = &H105

'----------------------
' gesendeter tastencode
'----------------------
Private Const VK_OEM_PERIOD = &HBE ' hier: "."

'--------------------
' weitere Tastencodes
'--------------------
'Virtual key constants
Private Const VK_TAB = &H9
Private Const VK_CONTROL = &H11
Private Const VK_ESCAPE = &H1B
Private Const VK_space = &H20

'====================
' Konstanten fr Hook
'====================
Public Const HC_ACTION = 0&

'Konstante fr Keyboardhook
Public Const WH_KEYBOARD_LL = 13&

'=====================
'udt fr Tastaturwerte
'=====================
Private Type KBDLLHOOKSTRUCT
    vkCode As Long
    scanCode As Long
    flags As Long
    time As Long
    dwExtraInfo As Long
End Type

'=============================
' Funktionen fr Tastatur-Hook
'=============================
' Hook fr Tastaturberwachung
' (filter-type = wh_keyboard_ll) einschalten
Declare Function SetWindowsHookEx _
        Lib "user32" _
        Alias "SetWindowsHookExA" ( _
        ByVal nFilterType As Long, _
        ByVal hkPrc As Long, _
        ByVal hMod As Long, _
        ByVal dwThreadId As Long) As Long

' Hook fr Tastaturberwachung wieder ausschalten
Declare Function UnhookWindowsHookEx Lib "user32" _
        (ByVal hHook As Long) As Long

' Informationen an nchsten Hook weitergeben
Declare Function CallNextHookEx Lib "user32" _
        (ByVal hHook As Long, _
        ByVal nCode As Long, _
        ByVal wParam As Long, _
        ByVal lParam As Long) As Long
    
' Rckgabe der Tastatur auf kbddlhs-Variable kopieren
Declare Sub CopyMemory Lib "kernel32" _
        Alias "RtlMoveMemory" _
        (pDest As Any, pSource As Any, ByVal cb As Long)
        
'==================================
' Funktionen um das Objekt, welches
' den Fokus hat, zu ermitteln
'==================================
Private Declare Function GetClassName _
        Lib "user32" Alias "GetClassNameA" ( _
        ByVal hwnd As Long, _
        ByVal lpClassName _
        As String, _
        ByVal nMaxCount As Long) As Long

Private Declare Function GetForegroundWindow Lib "user32" () As Long

Private Declare Function GetWindowThreadProcessId Lib "user32" _
        (ByVal hwnd As Long, lpdwProcessId As Long) As Long
    
Private Declare Function AttachThreadInput Lib "user32" (ByVal _
        idAttach As Long, ByVal idAttachTo As Long, ByVal fAttach _
        As Long) As Long

Private Declare Function GetFocus Lib "user32" () As Long

'=====================
' Nachrichten schicken
'=====================
Private Declare Function SendMessage Lib "user32" Alias _
        "SendMessageA" (ByVal hwnd As Long, ByVal wMsg _
        As Long, ByVal wParam As Long, lParam As Long) _
        As Long

Private Declare Function PostMessage Lib "user32" Alias _
        "PostMessageA" (ByVal hwnd As Long, ByVal wMsg _
        As Long, ByVal wParam As Long, ByVal lParam As _
        Long) As Long

'=====================
' Variablendeklaration
'=====================

' Rckgabe des Hooks
Public kbHookRet As Long


' Tastatureingabe auswerten
Public Function LowLevelKeyboardProc(ByVal nCode As Long, _
                                     ByVal wParam As Long, _
                                     ByVal lParam As Long) As Long
    Static kbDllhs As KBDLLHOOKSTRUCT
    Dim blnKeyBlocked As Boolean
    Dim test As Long
    
    If nCode = HC_ACTION Then
        Call CopyMemory(kbDllhs, ByVal lParam, Len(kbDllhs))
        blnKeyBlocked = False
        
        ' key down
        If kbDllhs.flags = 0 Then
            
            ' virtueller Tastencode = 110 (Komma)
            If kbDllhs.vkCode = 110 Then
                
                ' Nachricht an aktives Fenster schicken
                ' (Tastatureingabe, keydown) hat auch mit
                ' Senkeys funktioniert (ist aber meiner
                ' Meinung nach nicht so toll)
                PostMessage GetControl, WM_KEYDOWN, ByVal VK_OEM_PERIOD, 0&
                
                'ursprngliche Tastatureingabe nicht weitergeben
                LowLevelKeyboardProc = 1
                
            Else
                'ursprngliche Tastatureingabe weitergeben
                LowLevelKeyboardProc = CallNextHookEx(kbHookRet, nCode, wParam, lParam)
            End If
        End If
        
        ' key up
        If kbDllhs.flags = 128 Then
            ' virtueller Tastencode = 110 (komma)
            
            If kbDllhs.vkCode = 110 Then
                ' Nachricht an aktives Fenster schicken
                ' (Tastatureingabe, keyup) hat auch mit
                ' Senkeys funktioniert (ist aber meiner
                ' Meinung nach nicht so toll)
                
                'Anmerkung von Jochen Wierum (JoWi@ActiveVB.de):
                '  Ich habe die Zeile deaktiviert, da sonst bei einem
                '  Tastendruck immer 2 Punkte erzeugt wurden. Falls es
                '  in dieser Konfiguration Probleme geben sollte, bitte
                '  den Kommentar vor der folgenden Zeile entfernen:
                
                'PostMessage GetControl, WM_KEYUP, ByVal VK_OEM_PERIOD, 0&
                
                'ursprngliche Tastatureingabe nicht weitergeben
                LowLevelKeyboardProc = 1
            Else
                'ursprngliche Tastatureingabe weitergeben
                LowLevelKeyboardProc = CallNextHookEx(kbHookRet, nCode, wParam, lParam)
            End If
        End If
    End If
End Function

'-------------------------------------------------------
' Objekt (Textfeld,....) welches den Fokus hat ermitteln
Private Function GetControl() As Long
    Dim OtherThreadID As Long
    Dim Thread1 As Long
    Dim Thread2 As Long
    Dim bMerker As Boolean
    Dim GetCurrentThreadID As Long
          
    Thread1 = GetWindowThreadProcessId(frmKeyChange.hwnd, GetCurrentThreadID)
    Thread2 = GetWindowThreadProcessId(GetForegroundWindow, OtherThreadID)
    If Thread1 <> Thread2 Then bMerker = AttachThreadInput(Thread2, Thread1, True)
    GetControl = GetFocus()
End Function
